"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.compilers = void 0;
exports.one = one;
exports.oneOrMore = oneOrMore;
exports.optionally = optionally;
exports.zeroOrMore = zeroOrMore;
var _utils = require("./utils");
function oneOrMore(...children) {
  return {
    type: 'oneOrMore',
    children
  };
}
function optionally(...children) {
  return {
    type: 'optionally',
    children
  };
}
function one(...children) {
  return {
    type: 'one',
    children
  };
}
function zeroOrMore(...children) {
  return {
    type: 'zeroOrMore',
    children
  };
}
const compilers = exports.compilers = {
  one: compiledChildren => compiledChildren,
  oneOrMore: compiledChildren => `${(0, _utils.wrapGroup)(compiledChildren)}+`,
  optionally: compiledChildren => `${(0, _utils.wrapGroup)(compiledChildren)}?`,
  zeroOrMore: compiledChildren => `${(0, _utils.wrapGroup)(compiledChildren)}*`
};
//# sourceMappingURL=quantifiers.js.map